Index: /trunk/src/lib/network/handshake.cc
===================================================================
--- /trunk/src/lib/network/handshake.cc	(revision 7953)
+++ /trunk/src/lib/network/handshake.cc	(revision 7954)
@@ -24,5 +24,5 @@
 #include <cassert>
 
-Handshake::Handshake( bool server, int clientId, int networkGameManagerId )
+Handshake::Handshake( bool server, int clientId, int networkGameManagerId, int messageManagerId )
   : Synchronizeable()
 {
@@ -31,175 +31,84 @@
 
   this->setIsServer(server);
-  this->clientId = clientId;
-  this->networkGameManagerId = networkGameManagerId;
-  this->state = 0;
-  this->isOk = false;
-  this->setOwner(0);
+ 
+  orxId_handler = registerVarId( new SynchronizeableInt( &localState.orxId, &remoteState.orxId, "orxonoxId", PERMISSION_ALL ) );
+  version_handler = registerVarId( new SynchronizeableInt( &localState.version, &remoteState.version, "version", PERMISSION_ALL ) );
+  netManId_handler = registerVarId( new SynchronizeableInt( &localState.networkManagerId, &remoteState.networkManagerId, "networkManagerId", PERMISSION_ALL ) );
+  msgManId_handler = registerVarId( new SynchronizeableInt( &localState.messageManagerId, &remoteState.messageManagerId, "messageManagerId", PERMISSION_ALL ) );
+  hostId_handler = registerVarId( new SynchronizeableInt( &localState.hostId, &remoteState.hostId, "hostId", PERMISSION_ALL ) );
+  completed_handler = registerVarId( new SynchronizeableInt( &localState.completed, &remoteState.completed, "completed", PERMISSION_ALL ) );
+  error_handler = registerVarId( new SynchronizeableInt( &localState.error, &remoteState.error, "error", PERMISSION_ALL ) );
+  errorString_handler = registerVarId( new SynchronizeableString( &localState.errorString, &remoteState.errorString, "errorString", PERMISSION_ALL ) );
+  
+  candel_id = registerVarId( new SynchronizeableInt( &localState.canDel, &remoteState.canDel, "canDel", PERMISSION_ALL ) );
+  
+  localState.completed = 0;
+  localState.error = 0;
+  localState.errorString = "";
+  localState.hostId = clientId;
+  localState.networkManagerId = networkGameManagerId;
+  this->localState.messageManagerId = messageManagerId;
+  localState.orxId = _ORXONOX_ID;
+  localState.version = _ORXONOX_VERSION;
+  localState.canDel = 0;
+  
+  remoteState.completed = 0;
+  remoteState.error = 0;
+  remoteState.errorString = "";
+  remoteState.hostId = -1;
+  remoteState.networkManagerId = -1;
+  remoteState.messageManagerId = -1;
+  remoteState.orxId = 0;
+  remoteState.version = 0;
+  remoteState.canDel = 0;
 
   this->setSynchronized(true);
-  PRINTF(5)("Handshake created clientId = %d\n", clientId);
+  PRINTF(0)("Handshake created clientId = %d\n", clientId);
 }
 
-int Handshake::writeBytes( const byte * data, int length, int sender)
+/**
+ * handler for changes in synced vars
+ * @param id id's which have changed
+ */
+void Handshake::varChangeHandler( std::list< int > & id )
 {
-  PRINTF(5)("Handshake::writeBytes states = %d %d %d %d (%d)\n", hasState( HS_RECVD_INIT ), hasState( HS_RECVD_VER ), hasState( HS_RECVD_HID ), hasState( HS_COMPLETED ), state);
+  for ( std::list<int>::iterator it = id.begin(); it != id.end(); it++ )
+  {
+    if ( *it == orxId_handler )
+    {
+      if ( remoteState.orxId != _ORXONOX_ID )
+      {
+        localState.error = 1;
+        localState.completed = 1;
+        localState.errorString = "Seems not to be orxonox!";
+        continue;
+      }
 
-  SYNCHELP_READ_BEGIN();
+    }
+     
+    if ( *it == version_handler )
+    {
+      if ( remoteState.version != _ORXONOX_VERSION )
+      {
+        localState.error = 2;
+        localState.completed = 1;
+        localState.errorString = "Versions of server and client do not match!";
+        continue;
+      }
 
-  if ( hasState( HS_COMPLETED ) )
-       return 0;
-
-  if ( !hasState( HS_RECVD_INIT ) )
-  {
-    if ( length != _INITIAL_DATA_LENGTH )
+    }
+    
+    if ( *it == candel_id )
     {
-      PRINTF(0)("initial packet has wrong size %d instead of %d\n", length, _INITIAL_DATA_LENGTH);
-      setState( HS_COMPLETED );
-      return 0;
+      PRINTF(0)("handshake finished candel changed\n");
     }
-
-    if ( strncmp((char*)data, _INITIAL_DATA, length) )
-    {
-      PRINTF(0)("initial packed does not match\n");
-      setState( HS_COMPLETED );
-      return length;
-    }
-
-    setState( HS_RECVD_INIT );
-    PRINTF(0)("got valid initial packet from client %d\n", clientId);
-    return length;
+    
   }
-
-  if ( hasState( HS_RECVD_INIT ) && !hasState( HS_RECVD_VER ) )
-  {
-    if ( length != _ORXONOX_VERSION_LENGTH )
-    {
-      PRINTF(0)("version number packet has wrong size %d instead of %d\n", length, _ORXONOX_VERSION_LENGTH);
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    if ( strncmp((char*)data, _ORXONOX_VERSION, length) )
-    {
-      PRINTF(0)("versions do not match\n");
-      setState( HS_COMPLETED );
-      return length;
-    }
-
-    setState( HS_RECVD_VER );
-
-    PRINTF(0)("client %d's version does match\n", clientId);
-    return length;
-  }
-
-  if ( !isServer() && hasState( HS_RECVD_VER ) && !hasState( HS_RECVD_HID ) )
-  {
-    /*if ( length != INTSIZE+INTSIZE )
-    {
-      PRINTF(0)("hostID packet has wrong size %d instead of %d\n", length, INTSIZE+INTSIZE);
-      setState( HS_COMPLETED );
-      return 0;
-  }*/
-
-    setState( HS_COMPLETED );
-    setState( HS_RECVD_HID );
-    this->isOk = true;
-    SYNCHELP_READ_INT( this->newHostId, NWT_HS_HOST_ID );
-    SYNCHELP_READ_INT( this->newNetworkGameManagerId, NWT_HS_NGM_ID );
-
-    if ( newHostId == 0 )
-    {
-      setState( HS_WAS_REJECT );
-      isOk = false;
-      PRINTF(0)("Server did not accept handshake!\n");
-    }
-    else
-    {
-      PRINTF(0)("got my hostID: %d and networkGameManagerId: %d\n", newHostId, newNetworkGameManagerId);
-    }
-    return SYNCHELP_READ_N;
-  }
-
+  
+  if (
+      remoteState.orxId == _ORXONOX_ID &&
+      remoteState.version == _ORXONOX_VERSION
+     )
+    localState.completed = 1;
 }
 
-int Handshake::readBytes( byte * data, int maxLength, int * reciever )
-{
-  PRINTF(5)("Handshake::readBytes states = %d %d %d %d (%d)\n", hasState( HS_SENT_INIT ), hasState( HS_SENT_VER ), hasState( HS_SENT_HID ), hasState( HS_COMPLETED ), state);
-
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( hasState( HS_COMPLETED ) )
-    return 0;
-
-  if ( !hasState( HS_SENT_INIT ) )
-  {
-    if ( maxLength < _INITIAL_DATA_LENGTH )
-    {
-      PRINTF(0)("buffer too small for _INITIAL_DATA");
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    setState( HS_SENT_INIT );
-    memcpy(data, _INITIAL_DATA, _INITIAL_DATA_LENGTH);
-    if ( this->isServer() )
-      *reciever = clientId;
-    return _INITIAL_DATA_LENGTH;
-  }
-
-  if ( hasState( HS_RECVD_INIT ) && hasState( HS_SENT_INIT ) && !hasState( HS_SENT_VER ) )
-  {
-    if ( maxLength < _ORXONOX_VERSION_LENGTH )
-    {
-      PRINTF(0)("buffer too small for version number");
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    setState( HS_SENT_VER );
-    memcpy(data, _ORXONOX_VERSION, _ORXONOX_VERSION_LENGTH);
-    if ( this->isServer() )
-      *reciever = clientId;
-    return _ORXONOX_VERSION_LENGTH;
-  }
-
-  if ( isServer() && hasState( HS_RECVD_VER) && hasState( HS_SENT_VER ) && !hasState( HS_SENT_HID ) )
-  {
-    if ( maxLength < 2 )
-    {
-      PRINTF(0)("buffer too small for ID");
-      setState( HS_COMPLETED );
-      return 0;
-    }
-
-    setState( HS_SENT_HID );
-    setState( HS_COMPLETED );
-
-    if ( hasState( HS_DO_REJECT ) )
-    {
-      isOk = false;
-      //memcpy(data, (byte*)0, 4);
-      SYNCHELP_WRITE_INT( 0, NWT_HS_HOST_ID);
-      SYNCHELP_WRITE_INT( 0, NWT_HS_NGM_ID);
-    }
-    else
-    {
-      isOk = true;
-      //memcpy(data, &clientId, 4);
-      SYNCHELP_WRITE_INT( clientId, NWT_HS_HOST_ID );
-      SYNCHELP_WRITE_INT( networkGameManagerId, NWT_HS_NGM_ID );
-    }
-    *reciever = clientId;
-    return SYNCHELP_WRITE_N;
-  }
-
-  return 0;
-}
-
-void Handshake::writeDebug( ) const
-{
-}
-
-void Handshake::readDebug( ) const
-{
-}
Index: /trunk/src/lib/network/handshake.h
===================================================================
--- /trunk/src/lib/network/handshake.h	(revision 7953)
+++ /trunk/src/lib/network/handshake.h	(revision 7954)
@@ -10,23 +10,22 @@
 #include "synchronizeable.h"
 
-#define _INITIAL_DATA "orxonox"
-#define _INITIAL_DATA_LENGTH 7
+#define _ORXONOX_ID 0xF91337A0
 
-#define _ORXONOX_VERSION "\x00\x00\x00\x01"
-#define _ORXONOX_VERSION_LENGTH 4
+#define _ORXONOX_VERSION 1
 
-typedef enum HandshakeState {
-  HS_SENT_INIT  = 0x00000001,
-  HS_RECVD_INIT = 0x00000002,
-  HS_SENT_VER   = 0x00000004,
-  HS_RECVD_VER  = 0x00000008,
-  HS_SENT_HID   = 0x00000010,
-  HS_RECVD_HID  = 0x00000020,
-  HS_COMPLETED  = 0x00000040,
-
-  HS_DO_REJECT  = 0x00010000,
-  HS_WAS_REJECT = 0x00020000,
-
-  NUM_STATES
+struct HandshakeState {
+  int orxId;
+  int version;
+  
+  int networkManagerId;
+  int messageManagerId;
+  int hostId;
+  
+  int completed;
+  int canDel;
+  
+  int error;
+  
+  std::string errorString;
 };
 
@@ -34,28 +33,30 @@
 {
   public:
-    Handshake(bool server, int clientId = 0, int networkGameManagerId = 0);
-    inline bool       completed(){ return hasState( HS_COMPLETED ); }
-    inline bool       ok(){ return isOk; }
-    inline int        getHostId(){ return newHostId; }
-    inline int        getNetworkGameManagerId(){ return newNetworkGameManagerId; }
-
-    inline void       doReject(){ setState(HS_DO_REJECT); }
-
-    virtual int       writeBytes(const byte* data, int length, int sender);
-    virtual int       readBytes(byte* data, int maxLength, int * reciever);
-    virtual void      writeDebug() const;
-    virtual void      readDebug() const;
+    Handshake( bool server, int clientId = 0, int networkGameManagerId = 0, int messageManagerId = 0 );
+    inline bool       completed(){ return localState.completed != 0 && remoteState.completed != 0; }
+    inline bool       ok(){ return localState.error == 0 && remoteState.error == 0; }
+    inline int        getHostId(){ return remoteState.hostId; }
+    inline int        getNetworkGameManagerId(){ return remoteState.networkManagerId; }
+    inline int        getMessageManagerId(){ return remoteState.messageManagerId; }
+    inline void       doReject( std::string reason ){ localState.error = 1; localState.errorString = "the server rejected your connection ["+ reason +"]"; }
+    inline bool       canDel(){ return localState.canDel == 1 && remoteState.canDel == 1; }
+    inline bool       allowDel(){ return localState.canDel == 1; }
+    inline void       del(){ localState.canDel = 1; }
+    
+    virtual void varChangeHandler( std::list<int> & id );
 
   private:
-    int               state;
-    int               clientId;
-    int               networkGameManagerId;
-    int               newHostId;
-    int               newNetworkGameManagerId;
-    bool              isOk;
-
-    inline bool       hasState( int a ){ return (state & a) == a; }
-    inline void       setState( int a ){ state = state | a; }
-    inline void       unsetState( int a ){ state = state & (~a); }
+    HandshakeState localState;
+    HandshakeState remoteState;
+    
+    int netManId_handler;
+    int msgManId_handler;
+    int hostId_handler;
+    int completed_handler;
+    int error_handler;
+    int errorString_handler;
+    int orxId_handler;
+    int version_handler;
+    int candel_id;
 
 };
Index: /trunk/src/lib/network/message_manager.cc
===================================================================
--- /trunk/src/lib/network/message_manager.cc	(revision 7954)
+++ /trunk/src/lib/network/message_manager.cc	(revision 7954)
@@ -0,0 +1,330 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "message_manager.h"
+
+using namespace std;
+
+MessageManager* MessageManager::singletonRef = NULL;
+
+
+/**
+ * standard constructor
+*/
+MessageManager::MessageManager ()
+{
+  this->setClassID( CL_MESSAGE_MANAGER, "MessageManager" );
+  newNumber = 1;
+  setSynchronized( true );
+}
+
+
+/**
+ * standard deconstructor
+*/
+MessageManager::~MessageManager ()
+{
+  for ( MessageQueue::iterator it = messageQueue.begin(); it != messageQueue.end(); it++ )
+  {
+    for ( std::list<NetworkMessage>::iterator it2 = it->second.messages.begin(); it2 != it->second.messages.end(); it2++ )
+    {
+      if ( it2->data )
+      {
+        delete it2->data;
+        it2->data = NULL;
+      }
+    }
+    
+    it->second.messages.clear();
+    it->second.toAck.clear();
+  }
+  
+  messageQueue.clear();
+}
+
+/**
+ * get the diff to last acked state of userId
+ *
+ * this class does not use the normal SynchronizeableVars for zynchronisation. instead
+ * it defines its own protocol
+ *
+ * @param userId user to create diff for
+ * @param data buffer to copy diff in
+ * @param maxLength max bytes to copy into data
+ * @param stateId id of current state
+ * @param fromStateId the reference state for the delta state
+ * @param priorityTH tells getStateDiff to not send element with priority \< priorityTH
+ * @return n bytes copied into data
+ */
+int MessageManager::getStateDiff( int userId, byte * data, int maxLength, int stateId, int fromStateId, int priorityTH )
+{
+  int i = 0;
+  int n;
+  
+  n = Converter::intToByteArray( messageQueue[userId].toAck.size(), data + i, maxLength );
+  i += n;
+  assert( n == INTSIZE );
+  
+  for ( std::list<int>::iterator it = messageQueue[userId].toAck.begin(); it != messageQueue[userId].toAck.end(); it++)
+  {
+    n = Converter::intToByteArray( *it, data + i, maxLength );
+    i += n;
+    assert( n == INTSIZE );
+  }
+  
+  messageQueue[userId].toAck.clear();
+  
+  n = Converter::intToByteArray( messageQueue[userId].messages.size(), data + i, maxLength );
+  i += n;
+  assert( n == INTSIZE );
+  
+  for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end(); it++ )
+  {
+    n = Converter::intToByteArray( it->length, data + i, maxLength );
+    i += n;
+    assert( n == INTSIZE );
+    
+    n = Converter::intToByteArray( it->number, data + i, maxLength );
+    i += n;
+    assert( n == INTSIZE );
+    
+    n = Converter::intToByteArray( it->messageId, data + i, maxLength );
+    i += n;
+    assert( n == INTSIZE );
+    
+    assert( i + it->length <= maxLength );
+    memcpy( data + i, it->data, it->length );
+    i += it->length;
+  }
+  
+  return i;
+}
+
+/**
+ * sets a new state out of a diff created on another host
+ * @param userId hostId of user who send me that diff
+ * @param data pointer to diff
+ * @param length length of diff
+ * @param stateId id of current state
+ * @param fromStateId id of the base state id
+ * @return number bytes read
+ * @todo check for permissions
+ */
+int MessageManager::setStateDiff( int userId, byte * data, int length, int stateId, int fromStateId )
+{
+  int i = 0;
+  int n;
+  
+  int nAcks;
+  
+  assert( i + INTSIZE <= length );
+  n = Converter::byteArrayToInt( data + i, &nAcks );
+  assert( n == INTSIZE );
+  i += n;
+  
+  std::list<int> acks;
+  
+  int number;
+  
+  for ( int j = 0; j < nAcks; j++ )
+  {
+    assert( i + INTSIZE <= length );
+    n = Converter::byteArrayToInt( data + i, &number );
+    assert( n == INTSIZE );
+    i += n;
+    
+    acks.push_back( number );
+  }
+  
+  int nMessages;
+  
+  assert( i + INTSIZE <= length );
+  n = Converter::byteArrayToInt( data + i, &nMessages );
+  assert( n == INTSIZE );
+  i += n;
+
+  int messageLength, messageId;
+  
+  for ( int j = 0; j < nMessages; j++ )
+  {
+    assert( i + INTSIZE <= length );
+    n = Converter::byteArrayToInt( data + i, &messageLength );
+    assert( n == INTSIZE );
+    i += n;
+    
+    assert( i + INTSIZE <= length );
+    n = Converter::byteArrayToInt( data + i, &number );
+    assert( n == INTSIZE );
+    i += n;
+  
+    assert( i + INTSIZE <= length );
+    n = Converter::byteArrayToInt( data + i, &messageId );
+    assert( n == INTSIZE );
+    i += n;
+    
+    if ( number > 0 )
+      messageQueue[userId].toAck.push_back( number );
+    
+    assert( i + messageLength <= length );
+    assert( messageHandlerMap.find( (MessageId)messageId ) != messageHandlerMap.end() );
+    if ( std::find( messageQueue[userId].recievedMessages.begin(), messageQueue[userId].recievedMessages.end(), number )== messageQueue[userId].recievedMessages.end() )
+    {
+      if ( !(*(messageHandlerMap[(MessageId)messageId].cb))( (MessageId)messageId, data + i, messageLength, messageHandlerMap[(MessageId)messageId].someData, userId ) )
+      {
+        NetworkMessage msg;
+        
+        msg.data = new byte[messageLength];
+        memcpy( msg.data, data + i, messageLength );
+        msg.length = messageLength;
+        msg.messageId = (MessageId)messageId;
+        msg.number = userId;
+        
+        incomingMessabeBuffer.push_back( msg );
+      }
+      messageQueue[userId].recievedMessages.push_back( number );
+    }
+    i += messageLength;
+  }
+  
+  
+  for ( std::list<NetworkMessage>::iterator it = incomingMessabeBuffer.begin(); it != incomingMessabeBuffer.end();  )
+  {
+    if ( (*(messageHandlerMap[it->messageId].cb))( it->messageId, it->data, it->length, messageHandlerMap[it->messageId].someData, it->number ) )
+    {
+      std::list<NetworkMessage>::iterator delIt = it;
+      if ( it->data )
+        delete it->data;
+      it++;
+      incomingMessabeBuffer.erase( delIt );
+      continue;
+    }
+    it++;
+  }
+  
+  //walk throu message queue and remove acked messages
+  for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end();  )
+  {
+    if ( std::find( acks.begin(), acks.end(), it->number) != acks.end() )
+    {
+      std::list<NetworkMessage>::iterator delIt = it;
+      it++;
+      messageQueue[userId].messages.erase( delIt );
+      continue;
+    }
+    it++;
+  }
+  
+  //TODO find bether way. maybe with timestamp
+  if ( messageQueue[userId].recievedMessages.size() > 1000 )
+  {
+    for ( int j = 0; j < messageQueue[userId].recievedMessages.size() - 1000; j++ )
+      messageQueue[userId].recievedMessages.erase( messageQueue[userId].recievedMessages.begin() );
+  }
+
+  return i;
+}
+
+/**
+ * clean up memory reserved for user
+ * @param userId userid
+ */
+void MessageManager::cleanUpUser( int userId )
+{
+  if ( messageQueue.find( userId ) == messageQueue.end() )
+    return;
+    
+  for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end(); it++ )
+  {
+    if ( it->data )
+      delete it->data;
+    it->data = NULL;
+  }
+  
+  messageQueue[userId].toAck.clear();
+  
+  messageQueue.erase( userId );
+}
+
+/**
+ * registers function to handle messages with id messageId. someData is passed to callbackfuntion
+ * @param messageId message id to handle 
+ * @param cb function pointer to callback function
+ * @param someData this pointer is passed to callback function without modification
+ * @return true on success
+ */
+bool MessageManager::registerMessageHandler( MessageId messageId, MessageCallback cb, void * someData )
+{
+  MessageHandler messageHandler;
+  
+  messageHandler.cb = cb;
+  messageHandler.messageId = messageId;
+  messageHandler.someData = someData;
+  
+  messageHandlerMap[messageId] = messageHandler;
+  
+  return true;
+}
+
+/**
+ * initializes buffers for user
+ * @param userId userId
+ */
+void MessageManager::initUser( int userId )
+{
+  // just do something so map creates a new entry
+  messageQueue[userId].toAck.clear();
+  //assert( messageQueue[userId].messages.size() == 0 );
+}
+
+/**
+ * send a message to one or more clients
+ * recieverType:
+ *               RT_ALL send to all users. reciever is ignored
+ *               RT_USER send only to reciever
+ *               RT_NOT_USER send to all but reciever
+ *
+ * @param messageId message id
+ * @param data pointer to data
+ * @param dataLength length of data
+ * @param recieverType 
+ * @param reciever 
+ */
+void MessageManager::sendMessage( MessageId messageId, byte * data, int dataLength, RecieverType recieverType, int reciever, MessagePriority messagePriority )
+{
+  for ( MessageQueue::iterator it = messageQueue.begin(); it != messageQueue.end(); it++ )
+  {
+    if ( 
+         recieverType == RT_ALL ||
+         recieverType == RT_USER && it->first == reciever ||
+         recieverType == RT_NOT_USER && it->first != reciever
+       )
+    {
+      NetworkMessage msg;
+      
+      msg.data = new byte[dataLength];
+      memcpy( msg.data, data, dataLength );
+      msg.length = dataLength;
+      msg.messageId = messageId;
+      msg.number = newNumber++;
+      msg.priority = messagePriority;
+      
+      it->second.messages.push_back( msg );
+    }
+  }
+}
+
+
Index: /trunk/src/lib/network/message_manager.h
===================================================================
--- /trunk/src/lib/network/message_manager.h	(revision 7954)
+++ /trunk/src/lib/network/message_manager.h	(revision 7954)
@@ -0,0 +1,110 @@
+/*!
+ * @file message_manager.h
+ * @brief Definition of MessageManager
+*/
+
+#ifndef _MESSAGE_MANAGER_H
+#define _MESSAGE_MANAGER_H
+
+#include "synchronizeable.h"
+
+#include <map>
+#include <list>
+
+/*
+  Protocol:
+    int nacks
+    int acks[1..nacks]
+    int nmsg
+    (
+      int length
+      int number
+      int MessageId
+      byte * data
+    )[1..nmsg]
+*/
+
+
+enum MessageId 
+{
+  TESTMESSAGEID = 1,
+  MSGID_YOU_ARE
+};
+
+typedef bool (*MessageCallback)( MessageId messageId, byte * data, int dataLength, void * someData, int userId );
+
+enum RecieverType
+{
+  RT_ALL = 1,   //!< message is sent to all users
+  RT_USER,      //!< message is only sent to reciever
+  RT_NOT_USER   //!< message is sent to all but reciever
+};
+
+//TODO implement priority handling
+enum MessagePriority
+{
+  MP_HIGHBANDWIDTH = 1,  //!< fast and reliable but uses a lot of bandwidth
+  MP_LOWBANDWIDTH,       //!< may take a long time to arrive. reliable
+  MP_UNRELIABLE          //!< unreliable. low bandwidth 
+};
+
+struct NetworkMessage
+{
+  MessageId        messageId;
+  byte *           data;
+  int              length;
+  int              number;
+  MessagePriority  priority;
+};
+
+struct MessageUserQueue
+{
+  std::list<NetworkMessage> messages;
+  std::list<int>            toAck;
+  std::list<int>            recievedMessages;
+};
+
+typedef std::map<int,MessageUserQueue> MessageQueue;
+
+struct MessageHandler
+{
+  MessageCallback cb;
+  MessageId       messageId;
+  void *          someData;
+};
+
+typedef std::map<MessageId,MessageHandler> MessageHandlerMap;
+
+//! A class for sending messages over network
+class MessageManager : public Synchronizeable {
+ protected:
+   MessageManager();
+ public:
+   inline static MessageManager * getInstance(){ if (!singletonRef) singletonRef = new MessageManager();  return singletonRef; }
+   
+   virtual ~MessageManager();
+   
+   bool registerMessageHandler( MessageId messageId, MessageCallback cb, void * someData );
+   
+   void sendMessage( MessageId messageId, byte * data, int dataLength, RecieverType recieverType, int reciever, MessagePriority messagePriority );
+
+   virtual int getStateDiff( int userId, byte* data, int maxLength, int stateId, int fromStateId, int priorityTH );
+   virtual int setStateDiff( int userId, byte* data, int length, int stateId, int fromStateId );
+   virtual void cleanUpUser( int userId );
+   virtual void handleSentState( int userId, int stateId, int fromStateId ){}
+   virtual void handleRecvState( int userId, int stateId, int fromStateId ){}
+   
+   void initUser( int userId );
+
+
+ private:
+   static MessageManager *   singletonRef;
+   MessageQueue              messageQueue;           //!< stores messages to send
+   MessageHandlerMap         messageHandlerMap;      //!< contains handlers for messages
+
+   int                       newNumber;              //!< used to create unique message numbers
+   std::list<NetworkMessage> incomingMessabeBuffer; 
+
+};
+
+#endif /* _PROTO_CLASS_H */
Index: /trunk/src/lib/network/netdefs.h
===================================================================
--- /trunk/src/lib/network/netdefs.h	(revision 7953)
+++ /trunk/src/lib/network/netdefs.h	(revision 7954)
@@ -19,4 +19,6 @@
 #define MAX_CONNECTIONS 1000
 
+#define NETWORK_FREQUENCY 33
+
 
 typedef unsigned char byte;
@@ -28,4 +30,9 @@
 } NodeType;
 
+typedef enum ConnectionType {
+  NET_UDP = 0,
+  NET_TCP
+};
+
 
 typedef enum {
